searchData={"items":[{"type":"module","title":"Zarex","doc":"Filename sanitization for Elixir. This is useful when you generate filenames for downloads from user input.\n\nZarex takes a given filename and normalizes, filters and truncates it.\n\nIt deletes the bad stuff but leaves unicode characters in place, so users can\nuse whatever alphabets they want to. Zarex also doesn't remove whitespace—instead,\nany sequence of whitespace that is 1 or more characters in length is collapsed to a\nsingle space. Filenames are truncated so that they are at maximum 255 bytes long.\n\n#","ref":"Zarex.html"},{"type":"module","title":"Examples - Zarex","doc":"iex> Zarex.sanitize(\"  whatēver//wëird:user:înput:\")\n    \"whatēverwëirduserînput\"\n\n    iex> Zarex.sanitize(\"<\", filename_fallback: \"file\")\n    \"file\"","ref":"Zarex.html#module-examples"},{"type":"function","title":"Zarex.sanitize/2","doc":"Takes a given filename and normalizes, filters and truncates it.\n\n  If extra breathing room is required (for example to add your own filename\n  extension later), you can leave extra room with the padding parameter","ref":"Zarex.html#sanitize/2"},{"type":"type","title":"Zarex.options/0","doc":"","ref":"Zarex.html#t:options/0"},{"type":"extras","title":"Zarex","doc":"Zarex\n=====\n\n[![Elixir CI](https://github.com/ricn/zarex/actions/workflows/elixir.yml/badge.svg)](https://github.com/ricn/zarex/actions/workflows/elixir.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/zarex.svg)](https://hex.pm/packages/zarex)\n\nFilename sanitization for Elixir. This is useful when you generate filenames for downloads from user input. The library is heavily inspired by\n[Zaru](https://github.com/madrobby/zaru) which does the same thing but in Ruby.","ref":"readme.html"},{"type":"extras","title":"Installation - Zarex","doc":"Add this to your `mix.exs` file, then run `mix do deps.get, deps.compile`:\n\n```elixir\n  {:zarex, \"~> 1.0\"}\n```","ref":"readme.html#installation"},{"type":"extras","title":"Examples - Zarex","doc":"```elixir\nZarex.sanitize(\"  what\\ēver//wëird:user:înput:\")\n# => \"whatēverwëirduserînput\"\n```\n\nZarex takes a given filename and normalizes, filters and truncates it.\n\nIt deletes the bad stuff and leaves unicode characters in place, so users can use whatever alphabets they want to. Zarex doesn't remove whitespace—instead, any sequence of whitespace that is 1 or more characters in length is collapsed to a single space. Filenames are truncated so that they are at maximum 255 characters long.\n\nIf extra space is required (for example to add your own filename extension later), you can leave extra padding:\n\n```elixir\nZarex.sanitize(String.duplicate(\"a\", 400), padding: 10)\n# returns a string with 245 chars. First the binary of 400 chars will be truncated\n# to 255 chars and then the extra padding of 10 will truncate the binary to 245 chars.\n```","ref":"readme.html#examples"},{"type":"extras","title":"Credits - Zarex","doc":"The following people have contributed ideas, documentation, or code to Zarex:\n\n* Richard Nyström\n* Thomas Fuchs (the creator of Zaru, the Ruby library Zarex is heavily based on)","ref":"readme.html#credits"},{"type":"extras","title":"Contributing - Zarex","doc":"1. Fork it\n2. Create your feature branch (`git checkout -b my-new-feature`)\n3. Commit your changes (`git commit -am 'Add some feature'`)\n4. Push to the branch (`git push origin my-new-feature`)\n5. Create new Pull Request","ref":"readme.html#contributing"}],"content_type":"text/markdown"}